class NsTranslator expands Translator;

var bool bAutoDeactivate, bIgnited;
var Vector TriggerLocation;

event Tick(float DT)
{
	if (bIgnited)
	{
		if ( bAutoDeactivate &&
			VSize(Owner.Location - TriggerLocation) > 100.0)
		{
			GotoState('Deactivated');
		if ( PlayerPawn(Owner) != None )
			PlayerPawn(Owner).ClearProgressMessages();
		}
		else
		{
			if ( PlayerPawn(Owner) != None && IsInState('Activated'));
				PlayerPawn(Owner).SetProgressTime(1);
		}
	}
}

simulated state Activated
{
	function BeginState()
	{
		local color ColorGold, ColorPink;
		if ( NewMessage != "Universal Translator" )
			bIgnited = True;
		super.BeginState();
		ColorGold.R = 254;
		ColorGold.G = 254;
		ColorPink.R = 254;
		ColorPink.G = 128;
		ColorPink.B = 254;
		if (bNewMessage || bNotNewMessage)
		{
			bAutoDeactivate = true;
			TriggerLocation = Owner.Location;
			if ( PlayerPawn(Owner) != None )
			{
				PlayerPawn(Owner).ClearProgressMessages();
				PlayerPawn(Owner).SetProgressMessage(NewMessage,1);
				PlayerPawn(Owner).SetProgressColor(ColorGold,1);
				PlayerPawn(Owner).SetProgressTime(1);
			}
		}
		else
		{
			bAutoDeactivate = false;
			if (PlayerPawn(Owner) != None )
			{
				PlayerPawn(Owner).ClearProgressMessages();
				PlayerPawn(Owner).SetProgressMessage(NewMessage,1);
				PlayerPawn(Owner).SetProgressColor(ColorGold,1);
				PlayerPawn(Owner).SetProgressTime(1);
			}
		}
	}
	function EndState()
	{
		bActive = false;
		bCurrentlyActivated = false;
		if ( PlayerPawn(Owner) != None )
			PlayerPawn(Owner).ClearProgressMessages();
		bIgnited=False;
	}
}

defaultproperties
{
	PickupMessage="You picked up the Translator."
	ItemName="Translator"
	M_Activated=""
	M_Deactivated=""
}
